<?
//    -------------------------------------------------------------------------
//    $Id: DebugBox.php,v 1.5 2002/12/22 13:27:32 jonen Exp $
//    -------------------------------------------------------------------------
//    $Log: DebugBox.php,v $
//    Revision 1.5  2002/12/22 13:27:32  jonen
//    + modified path to 'debugbox.js' according to new file structure under 'inc'
//
//    Revision 1.4  2002/12/03 17:48:42  joko
//    + bugfix - too fast making changes before  -  debug box stayed empty ;)
//
//    Revision 1.3  2002/12/03 17:39:38  joko
//    + don't have _any_ kind of php-errors in the (critical) startup-phase
//
//    Revision 1.2  2002/11/17 07:23:13  jonen
//    + small bugfix: really _no_ error should occour when javascript scope is not switched
//
//    Revision 1.1  2002/11/12 05:42:31  joko
//    + initial checkin
//
//    -------------------------------------------------------------------------


class Site_DebugBox {

function activate() {

  global $site, $debugbox_status;
  
  //print dumpvar($site); exit;
  if (!$site->config['mode']['DEBUGBOX']) { return; }
  
  $debugbox_status['active'] = 1;
  
  $width = 380;
  
  $debugbox_status['injs'] = 1;
  ?>
  
<div id="debugbox_control" align="right" style="position:absolute;top:0px;right:0px;border:1px solid black;padding:3px;font-family:Verdana,Helvetica,Arial;font-size:10px;z-index:99;">
  <a style="color:black;font-size:10px;" href="javascript:toggleBoxVisibility(1);">[ show ]</a><br>
  <a style="color:black;font-size:10px;" href="javascript:toggleBoxVisibility(0);">[ hide ]</a>
</div>
<div id="debugbox_control_2" align="right" style="visibility:hidden;position:absolute;top:35px;right:0px;border:1px solid black;font-family:Verdana,Helvetica,Arial;font-size:10px;padding:3px;z-index:99;">
  next...<br>
  <a id="usernotice" style="color:black;font-size:10px;" href="javascript:jumpToNext('usernotice');">[ dprint ]</a><br>
  <a id="phperror" style="color:black;font-size:10px;" href="javascript:jumpToNext('phperror');">[ error ]</a><br>
  <a id="phpnotice" style="color:black;font-size:10px;" href="javascript:jumpToNext('phpnotice');">[ notice ]</a><br>
</div>

<div id="debugbox" style="visibility:hidden;background:#dddddd;color:#000000;position:absolute;top:100px;width:<?= $width ?>px;right:0px;border:1px solid black;font-family:Verdana,Helvetica,Arial;font-size:10px;">
</div>

<script language="javascript">
  var debugbox_width = '<?= ($width - 10) . "px" ?>';
  var debugbox_level_E_USER_NOTICE = <?= E_USER_NOTICE ?>;
</script>

<script language="javascript" src="<?= $site->config['url']['base'] . 'inc/js/debugbox.js' ?>"></script>

  <?
    $debugbox_status['injs'] = 0;
}

function append($message, $level) {
  global $site, $debugbox_status;

  //print "msg: $message<br>";
  
  // TODO: queue messages here for later view when output started
  //if (!$debugbox_status) { return; }

  // don't do any output when not in html
  if (!$debugbox_status['inhtml']) { return; }

  if (!$site->config['mode']['DEBUGBOX']) { return; }
  if ($level > $site->config['mode']['DEBUGBOX_LEVEL'] && $level != E_USER_NOTICE) { return; }

  if (!isset($debugbox_status['active'])) { $debugbox_status['active'] = 0; }
  if (!isset($debugbox_status['injs'])) { $debugbox_status['injs'] = 0; }

  // don't do any output when inside javascript
  if ($debugbox_status['injs']) { return; }

  //$message = str_replace("\n", "", $message);
  //$message = str_replace("'", '', $message);
  //$message = str_replace('"', '', $message);
  //$message = quotemeta($message);
  //$message = addslashes($message);
  $message = urlencode($message);
  
  if ($debugbox_status['active'] == 1) {
    $store_method = 'dprint';
  } else {
    $store_method = 'debug_buffer.push';
    if ($debugbox_status['buffer_ok'] != 1) {
      $debugbox_status['buffer_ok'] = 1;
      $store_method = "debug_buffer = new Array(\"hello\"); " . $store_method;
    }
  }

  print "
  <script language=\"javascript\">
    $store_method(\"$message\", \"$level\");
  </script>\n";

}

}

?>